# -*- mode: ruby -*-
# vi: set ft=ruby :

Vagrant.configure("2") do |config|

  ###########################################################################
  ### Boudary - Database
  ###########################################################################
  config.vm.define "database" do |instance|
    instance.vm.box         = "pogosoftware/postgresql-11"
    instance.vm.hostname    = "postgresql.vagrant.local"
    
    instance.vm.network "private_network", ip: "10.7.0.6", virtualbox__intnet: "boundary"
    
    instance.vm.provider "virtualbox" do |vb|
      vb.gui    = false
      vb.name   = "Boudary - Database"
      vb.cpus   = 1
      vb.memory = 1024
    end

    instance.vm.provision "shell", path: "./scripts/postgresql_install.sh"
  end

  ###########################################################################
  ### Boudary - Controller Nodes
  ###########################################################################
  BoudaryControllerNodes = 2

  (1..BoudaryControllerNodes).each do |i|
    config.vm.define "controller#{i}" do |instance|
      instance.vm.box      = "pogosoftware/ubuntu-20.04"
      instance.vm.hostname = "controller#{i}.vagrant.local"
      
      instance.vm.network "private_network", ip: "10.7.0.1#{i-1}", virtualbox__intnet: "boundary"
      instance.vm.network "private_network", ip: "10.10.0.1#{i-1}"
      
      instance.vm.provider "virtualbox" do |vb|
        vb.gui    = false
        vb.name   = "Boudary - Controller #{i}"
        vb.cpus   = 1
        vb.memory = 1024
      end
    end
  end

  ###########################################################################
  ### Boudary - Worker Nodes
  ###########################################################################
  BoudaryWorkerNodes = 1

  (1..BoudaryWorkerNodes).each do |i|
    config.vm.define "worker#{i}" do |instance|
      instance.vm.box      = "pogosoftware/ubuntu-20.04"
      instance.vm.hostname = "controller#{i}.vagrant.local"
      
      instance.vm.network "private_network", ip: "10.7.0.2#{i-1}", virtualbox__intnet: "boundary"
      instance.vm.network "private_network", ip: "10.10.0.2#{i-1}"
      
      instance.vm.provider "virtualbox" do |vb|
        vb.gui    = false
        vb.name   = "Boudary - Worker #{i}"
        vb.cpus   = 1
        vb.memory = 1024
      end
    end
  end
end
